package com.example.request;

import org.eclipse.gef.Request;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.AbstractEditPolicy;
import org.eclipse.swt.graphics.RGB;

import com.example.model.Node;

/**
 * @author zhanghao
 *
 */
public class ChangeColorEditPolicy extends AbstractEditPolicy {
	final static public String CHANGE_COLOR_ROLE = "CHANGE_COLOR_ROLE";

	@Override
	public Command getCommand(Request request) {
		//Judge whether this request is intersting by its type
		if (request.getType() == ChangeColorRequest.REQ_CHANGE_COLOR) {
			ChangeColorRequest theRequest = (ChangeColorRequest) request;
			
			//Get information from request
			Node node = theRequest.getNode();
			RGB color = theRequest.getColor();
			
			//Create corresponding command and return it
			ChangeColorCommand command = new ChangeColorCommand(node, color);
			return command;
		}
		return null;
	}
}
